import os
#this module for shift register (flip-flops)
L = ["te2","te1","t0","te0"]
M = ["te2","te1","t1","te0"]
pivot = 2 #position of t0. starts from 0
for x in range(1,4): #1,2,3,4,5,6,7
    filename = "trojanmul4x4trojan" + str(x) + ".smt2"
    with open("trojanmul4x4trojan0.smt2", "r") as myfile: #original file
        head = [next(myfile) for x in range(160)] #parse thru the first 164 lines
    f1 = open(filename,"w") #new smt file gets created here
    f1.writelines(head)
    text1 = ["					(trojan1 (concat "]
    f1.writelines(text1)
    f1.writelines(["%s " %item for item in L]) #paste L
    f1.writelines("))\n")
    text2 = ["					(trojan2 (concat "]
    f1.writelines(text2)
    f1.writelines(["%s " %item for item in M]) #paste M
    f1.writelines("))\n")
    with open("trojanmul4x4trojan0.smt2","r") as f:
        for i in range(162): #paste left over lines
            f.readline()
        for line in f:
            f1.writelines(line)
    f1.close()
    #os.system("cmd.exe /k z3 test.smt2 -st > output.txt")
    print (filename)
    temp1 = L[pivot]
    L[pivot] = L[pivot-1]
    L[pivot-1] = temp1
    temp1 = M[pivot]
    M[pivot] = M[pivot-1]
    M[pivot-1] = temp1
    pivot = pivot-1

#this module for inputs Xmul
J = ["xe2","xe1","a0","xe0"]
K = ["xe2","xe1","a1","xe0"]
pivot = 2
for x in range(1,4): #1,2,3
    filename = "trojanmul4x4inputx" + str(x) + ".smt2"
    with open("trojanmul4x4inputx0.smt2", "r") as myfile:
        head = [next(myfile) for x in range(161)]
    f1 = open(filename,"w")
    f1.writelines(head)
    text1 = ["					(Xmul1 (concat "]
    f1.writelines(text1)
    f1.writelines(["%s " %item for item in J]) #paste L
    f1.writelines("))\n")
    text2 = ["					(Xmul2 (concat "]
    f1.writelines(text2)
    f1.writelines(["%s " %item for item in K]) #paste M
    f1.writelines("))\n")
    with open("trojanmul4x4inputx0.smt2", "r") as f:
        for i in range(163):
            f.readline()
        for line in f:
            f1.writelines(line)
    f1.close()
    print (filename)
    temp1 = J[pivot]
    J[pivot] = J[pivot-1]
    J[pivot-1] = temp1
    temp1 = K[pivot]
    K[pivot] = K[pivot-1]
    K[pivot-1] = temp1
    pivot = pivot-1

#this module for inputs Ymul
J = ["ye2","ye1","a0","ye0"]
K = ["ye2","ye1","a1","ye0"]
pivot = 2
for x in range(1,4): #1,2,3
    filename = "trojanmul4x4inputy" + str(x) + ".smt2"
    with open("trojanmul4x4inputy0.smt2", "r") as myfile:
        head = [next(myfile) for x in range(161)]
    f1 = open(filename,"w")
    f1.writelines(head)
    text1 = ["					(Ymul1 (concat "]
    f1.writelines(text1)
    f1.writelines(["%s " %item for item in J]) #paste L
    f1.writelines("))\n")
    text2 = ["					(Ymul2 (concat "]
    f1.writelines(text2)
    f1.writelines(["%s " %item for item in K]) #paste M
    f1.writelines("))\n")
    with open("trojanmul4x4inputy0.smt2", "r") as f:
        for i in range(163):
            f.readline()
        for line in f:
            f1.writelines(line)
    f1.close()
    print (filename)
    temp1 = J[pivot]
    J[pivot] = J[pivot-1]
    J[pivot-1] = temp1
    temp1 = K[pivot]
    K[pivot] = K[pivot-1]
    K[pivot-1] = temp1
    pivot = pivot-1
