import os
#this module for shift register (flip-flops)
L = ["te2","te1","t0","te0"]
M = ["te2","te1","t1","te0"]
pivot = 2 #position of t0 
for x in range(1,4): #1,2,3...31
    filename = "trojanmul16x16trojan" + str(x) + ".smt2"
    with open("trojanmul16x16trojan0.smt2", "r") as myfile: #original file
        head = [next(myfile) for x in range(1225)] #parse thru the first 164 lines
    f1 = open(filename,"w") #new smt file gets created here
    f1.writelines(head)
    text1 = ["					(trojan1 (concat "]
    f1.writelines(text1)
    f1.writelines(["%s " %item for item in L]) #paste L
    f1.writelines("))\n")
    text2 = ["					(trojan2 (concat "]
    f1.writelines(text2)
    f1.writelines(["%s " %item for item in M]) #paste M
    f1.writelines("))\n")
    with open("trojanmul16x16trojan0.smt2","r") as f:
        for i in range(1227): #paste left over lines
            f.readline()
        for line in f:
            f1.writelines(line)
    f1.close()
    #os.system("cmd.exe /k z3 test.smt2 -st > output.txt")
    print (filename)
    temp1 = L[pivot]
    L[pivot] = L[pivot-1]
    L[pivot-1] = temp1
    temp1 = M[pivot]
    M[pivot] = M[pivot-1]
    M[pivot-1] = temp1
    pivot = pivot-1

#this module for inputs Xmul
J = ["xe14","xe13","xe12","xe11","xe10","xe9","xe8","xe7","xe6","xe5","xe4","xe3","xe2","xe1","a0","xe0"]
K = ["xe14","xe13","xe12","xe11","xe10","xe9","xe8","xe7","xe6","xe5","xe4","xe3","xe2","xe1","a1","xe0"]
pivot = 14
for x in range(1,16): #1,2,3...15
    filename = "trojanmul16x16inputx" + str(x) + ".smt2"
    with open("trojanmul16x16inputx0.smt2", "r") as myfile:
        head = [next(myfile) for x in range(1238)]
    f1 = open(filename,"w")
    f1.writelines(head)
    text1 = ["					(Xmul1 (concat "]
    f1.writelines(text1)
    f1.writelines(["%s " %item for item in J]) #paste L
    f1.writelines("))\n")
    text2 = ["					(Xmul2 (concat "]
    f1.writelines(text2)
    f1.writelines(["%s " %item for item in K]) #paste M
    f1.writelines("))\n")
    with open("trojanmul16x16inputx0.smt2", "r") as f:
        for i in range(1240):
            f.readline()
        for line in f:
            f1.writelines(line)
    f1.close()
    print (filename)
    temp1 = J[pivot]
    J[pivot] = J[pivot-1]
    J[pivot-1] = temp1
    temp1 = K[pivot]
    K[pivot] = K[pivot-1]
    K[pivot-1] = temp1
    pivot = pivot-1

#this module for inputs Ymul
J = ["ye14","ye13","ye12","ye11","ye10","ye9","ye8","ye7","ye6","ye5","ye4","ye3","ye2","ye1","a0","ye0"]
K = ["ye14","ye13","ye12","ye11","ye10","ye9","ye8","ye7","ye6","ye5","ye4","ye3","ye2","ye1","a1","ye0"]
pivot = 14
for x in range(1,16): #1,2,3
    filename = "trojanmul16x16inputy" + str(x) + ".smt2"
    with open("trojanmul16x16inputy0.smt2", "r") as myfile:
        head = [next(myfile) for x in range(1238)]
    f1 = open(filename,"w")
    f1.writelines(head)
    text1 = ["					(Ymul1 (concat "]
    f1.writelines(text1)
    f1.writelines(["%s " %item for item in J]) #paste L
    f1.writelines("))\n")
    text2 = ["					(Ymul2 (concat "]
    f1.writelines(text2)
    f1.writelines(["%s " %item for item in K]) #paste M
    f1.writelines("))\n")
    with open("trojanmul16x16inputy0.smt2", "r") as f:
        for i in range(1240):
            f.readline()
        for line in f:
            f1.writelines(line)
    f1.close()
    print (filename)
    temp1 = J[pivot]
    J[pivot] = J[pivot-1]
    J[pivot-1] = temp1
    temp1 = K[pivot]
    K[pivot] = K[pivot-1]
    K[pivot-1] = temp1
    pivot = pivot-1
