(declare-fun E () (_ BitVec 9))
(declare-fun A () (_ BitVec 9))
(declare-fun B () (_ BitVec 9))
(declare-fun C () (_ BitVec 9))
(declare-fun virus () (_ BitVec 7))
(declare-fun one () (_ BitVec 1))
(declare-fun zero () (_ BitVec 1))
(declare-fun array0 () (Array (_ BitVec 2) (_ BitVec 56)))
(declare-fun array1 () (Array (_ BitVec 2) (_ BitVec 56)))

;------------------------------------------------------------------------------------------
(define-fun mux2to1 ( (s0(_ BitVec 8)) (s1(_ BitVec 8)) (s(_ BitVec 1))) (_ BitVec 8)
	(ite (= s (_ bv0 1)) s0 s1)
)

;-----------------------------------------------------------------
(define-fun priorityA ((e(_ BitVec 9)) (a(_ BitVec 9)) (trojan(_ BitVec 8))) (_ BitVec 10)
	(let
		(
			(ab (bvnot a))
		)
	(let
		(
			(eab (bvnot (bvand ab e)))
		)
	(let
		(
			(nontrojan ((_ extract 8 1) eab))
			(select ((_ extract 0 0) eab))
		)
	(let
		(
			(temp1 (mux2to1 trojan nontrojan select))
			(temp2 (mux2to1 nontrojan trojan select))
			(selectprime (bvnot select))
		)
	(let
		(
			(eab8out (mux2to1 temp1 temp2 selectprime))
		)
	(let
		(
			(eab9 (concat eab8out select))
		)
	(let
		(
			(eab0 ((_ extract 0 0) eab9))
			(eab1 ((_ extract 1 1) eab9))
			(eab2 ((_ extract 2 2) eab9))
			(eab3 ((_ extract 3 3) eab9))
			(eab4 ((_ extract 4 4) eab9))
			(eab5 ((_ extract 5 5) eab9))
			(eab6 ((_ extract 6 6) eab9))
			(eab7 ((_ extract 7 7) eab9))
			(eab8 ((_ extract 8 8) eab9))
		)
	(let
		(
			(pa (bvnot (bvand eab0 eab1 eab2 eab3 eab4 eab5 eab6 eab7 eab8)))
		)
	(let
		(
			(pa9 (concat pa pa pa pa pa pa pa pa pa))
		)
	(let
		(
			(x1 (bvxor eab9 pa9))
		)
	(let
		(
			(out (concat pa x1))
		)
	)))))))))))
)

;---------------------------------------------------------------------
(define-fun priorityB ((e(_ BitVec 9)) (x1(_ BitVec 9)) (b(_ BitVec 9))) (_ BitVec 10)
	(let
		(
			(eb (bvnot e))
		)
	(let
		(
			(ebb (bvnot (bvor eb b)))
		)
	(let
		(
			(xeb (bvnot (bvand x1 ebb)))
		)
	(let
		(
			(xeb0 ((_ extract 0 0) xeb))
			(xeb1 ((_ extract 1 1) xeb))
			(xeb2 ((_ extract 2 2) xeb))
			(xeb3 ((_ extract 3 3) xeb))
			(xeb4 ((_ extract 4 4) xeb))
			(xeb5 ((_ extract 5 5) xeb))
			(xeb6 ((_ extract 6 6) xeb))
			(xeb7 ((_ extract 7 7) xeb))
			(xeb8 ((_ extract 8 8) xeb))
		)
	(let
		(
			(pb (bvnot (bvand xeb0 xeb1 xeb2 xeb3 xeb4 xeb5 xeb6 xeb7 xeb8)))
		)
	(let
		(
			(pb9 (concat pb pb pb pb pb pb pb pb pb))
		)
	(let
		(
			(x2 (bvxor xeb pb9))
		)
	(let
		(
			(out (concat pb x2))
		)
	))))))))	
)

;-------------------------------------------------------------------------------------
(define-fun priorityC ((e(_ BitVec 9)) (x1(_ BitVec 9)) (x2(_ BitVec 9)) (c(_ BitVec 9))) (_ BitVec 1)
	(let
		(
			(eb (bvnot e))
		)
	(let
		(
			(ebc (bvnot (bvor eb c)))
		)
	(let
		(
			(xec (bvnot (bvand x1 x2 ebc)))
		)
	(let
		(
			(xec0 ((_ extract 0 0) xec))
			(xec1 ((_ extract 1 1) xec))
			(xec2 ((_ extract 2 2) xec))
			(xec3 ((_ extract 3 3) xec))
			(xec4 ((_ extract 4 4) xec))
			(xec5 ((_ extract 5 5) xec))
			(xec6 ((_ extract 6 6) xec))
			(xec7 ((_ extract 7 7) xec))
			(xec8 ((_ extract 8 8) xec))
		)
	(let
		(
			(pc (bvnot (bvand xec0 xec1 xec2 xec3 xec4 xec5 xec6 xec7 xec8)))
		)
	)))))	
)

;------------------------------------------------------------------------------------------
(define-fun encodechan ((e(_ BitVec 9)) (a(_ BitVec 9)) (b(_ BitVec 9)) (c(_ BitVec 9)) (pa(_ BitVec 1)) (pb(_ BitVec 1)) (pc(_ BitVec 1))) (_ BitVec 9)
	(let
		(
			(pa9 (concat pa pa pa pa pa pa pa pa pa))
			
			(pb9 (concat pb pb pb pb pb pb pb pb pb))
			
			(pc9 (concat pc pc pc pc pc pc pc pc pc))
		)
	(let
		(
			(apa (bvnot (bvand a pa9)))
			(bpb (bvnot (bvand b pb9)))
			(cpc (bvnot (bvand c pc9)))
		)
	(let
		(
			(out (bvnot (bvand e apa bpb cpc)))
		)
	)))
)

;---------------------------------------------------------------------------------------------
(define-fun decodechan ((i(_ BitVec 9))) (_ BitVec 4)
	(let
		(
			(i0 ((_ extract 0 0) i))
			(i1 ((_ extract 1 1) i))
			(i2 ((_ extract 2 2) i))
			(i3 ((_ extract 3 3) i))
			(i4 ((_ extract 4 4) i))
			(i5 ((_ extract 5 5) i))
			(i6 ((_ extract 6 6) i))
			(i7 ((_ extract 7 7) i))
			(i8 ((_ extract 8 8) i))
		)
	(let
		(
			(i1b (bvnot i1))
			(i2b (bvnot i2))
			(i3b (bvnot i3))
			(i5b (bvnot i5))
			(i8b (bvnot i8))
		)
	(let
		(
			(iand (bvand i7 i6 i5 i4 i3 i2 i1 i0))
			(i56 (bvnot (bvand i5b i6)))
			(i245 (bvnot (bvand i2b i4 i5)))
			(i3456 (bvnot (bvand i3b i4 i5 i6)))
			(i1256 (bvnot (bvand i1b i2 i5 i6)))
		)
	(let
		(
			(chan3 (bvnot (bvor i8b iand)))
			(chan2 (bvnot (bvand i4 i6 i7 i56)))
			(chan1 (bvnot (bvand i6 i7 i245 i3456)))
			(chan0 (bvnot (bvand i7 i56 i1256 i3456)))
		)
	(let
		(
			(out (concat chan3 chan2 chan1 chan0))
		)
	)))))
)

(assert
	(not
		(let
			(
				(v0 ((_ extract 0 0) virus))
				(v1 ((_ extract 1 1) virus))
				(v2 ((_ extract 2 2) virus))
				(v3 ((_ extract 3 3) virus))
				(v4 ((_ extract 4 4) virus))
				(v5 ((_ extract 5 5) virus))
				(v6 ((_ extract 6 6) virus))
			)
		(let
			(
				(trojan0 (concat zero v6 v5 v4 v3 v2 v1 v0))
				(trojan1 (concat one v6 v5 v4 v3 v2 v1 v0))
			)
		(let
			(
				(priorityAout0 (priorityA E A trojan0))
				(priorityAout1 (priorityA E A trojan1))
			)
		(let
			(
				(PA0 ((_ extract 9 9) priorityAout0))
				(X10 ((_ extract 8 0) priorityAout0))
				
				(PA1 ((_ extract 9 9) priorityAout1))
				(X11 ((_ extract 8 0) priorityAout1))
			)
		(let
			(
				(out0 (concat (_ bv0 10) E A B C priorityAout0)) ;46
				(out1 (concat (_ bv0 10) E A B C priorityAout1))
			)
		(let
			(
				(array0 (store array0 (_ bv0 2) out0))
				(array1 (store array1 (_ bv0 2) out1))
			)
		(let
			(
				(priorityBout0 (priorityB E X10 B))
				(priorityBout1 (priorityB E X11 B))
			)
		(let
			(
				(PB0 ((_ extract 9 9) priorityBout0))
				(X20 ((_ extract 8 0) priorityBout0))
				
				(PB1 ((_ extract 9 9) priorityBout1))
				(X21 ((_ extract 8 0) priorityBout1))
			)
		(let
			(
				(out0 (concat E A B C priorityAout0 priorityBout0));56
				(out1 (concat E A B C priorityAout1 priorityBout1))
			)
		(let
			(
				(array0 (store array0 (_ bv1 2) out0))
				(array1 (store array1 (_ bv1 2) out1))
			)
		(let
			(
				(PC0 (priorityC E X10 X20 C))
				(PC1 (priorityC E X10 X21 C))
			)
		(let
			(
				(out0 (concat (_ bv0 17) E A B C PA0 PB0 PC0));39
				(out1 (concat (_ bv0 17) E A B C PA1 PB1 PC1))
			)
		(let
			(
				(array0 (store array0 (_ bv2 2) out0))
				(array1 (store array1 (_ bv2 2) out1))
			)
		(let
			(
				(I0 (encodechan E A B C PA0 PB0 PC0))
				(I1 (encodechan E A B C PA1 PB1 PC1))
			)
		(let
			(
				(chan0 (decodechan I0))
				(chan1 (decodechan I1))
			)
		(let
			(
				(output0 (concat (_ bv0 49) PA0 PB0 PC0 chan0));7
				(output1 (concat (_ bv0 49) PA0 PB0 PC1 chan1))
			)
		(let
			(
				(array0 (store array0 (_ bv3 2) output0))
				(array1 (store array1 (_ bv3 2) output1))
			)
		(=>
			(and (= zero (_ bv0 1)) (= one (_ bv1 1)))
			(= array0 array1)
		))))))))))))))))))
	)
)
		
(check-sat)
(get-model)